
#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>


#define FTP_PREFIX	"ftp://"
#define FTP_URL(x)	((x[0] == 'f') && \
		        (x[1] == 't') && \
	       		(x[2] == 'p') && \
	 		(x[3] == ':') && \
			(x[4] == '/') && \
			(x[5] == '/'))


#define FREE_FTP_STREAM(x)	do { \
					if (x) \
					{ \
						if(x->url_name) \
							free(x->url_name) ; \
						free(x) ;  \
						x = NULL ; \
					} \
				} while(0)





struct ftp_stream
{
	char           *url_name;	/* The ftp url in question.
					 * Dynamically allocated */
	long            current_pointer;	/* the position in the file */
	int             curl_handle_inited;	/* Whether we already have a
						 * curl here */
	CURL           *the_present_curl;	/* The curl */
	unsigned char  *buffer;	/* output buffer */
	int             buffer_size;	/* the size of the output buffer */
	int             bytes_to_be_read;	/* the number of bytes in the
						 * read request */
	int             copied_bytes;	/* number of bytes copied */
	double          file_length;	/* Length of file to be downloaded */

};




int
                curl_adap_read(void *stream, void *buf, unsigned int size);
struct ftp_stream *
                curl_adap_open_ftp_url(void *opaque, const char *urlname);
int
                curl_adap_close_ftp(void *stream);
int
                curl_adap_seek_end(struct ftp_stream *, unsigned long);
