/*
 * ioapi_url.c : ioapi adaptation for urls using libcurl
 * 
 * Bashuman Deb : bdev at hss.hns.com
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <zlib.h>
#include "ioapi.h"


#include "curl_adap.h"




#ifndef SEEK_CUR
#define SEEK_CUR    1
#endif

#ifndef SEEK_END
#define SEEK_END    2
#endif

#ifndef SEEK_SET
#define SEEK_SET    0
#endif

voidpf ZCALLBACK fopen_ftp_func 
OF((
    voidpf opaque,
    const char *filename,
    int mode));

	uLong ZCALLBACK fread_url_fun OF((
					                  voidpf opaque,
					                  voidpf stream,
					                  void *buf,
					                  uLong size));

	uLong ZCALLBACK fwrite_ftp_func OF((
					                    voidpf opaque,
					                    voidpf stream,
					                    const void *buf,
					                    uLong size));

	long ZCALLBACK ftell_ftp_func OF((
					                  voidpf opaque,
					                  voidpf stream));

	long ZCALLBACK fseek_ftp_func OF((
					                  voidpf opaque,
					                  voidpf stream,
					                  uLong offset,
					                  int origin));

	int ZCALLBACK fclose_ftp_func OF((
					                  voidpf opaque,
					                  voidpf stream));

	int ZCALLBACK ferror_ftp_func OF((
					                  voidpf opaque,
					                  voidpf stream));


	voidpf ZCALLBACK fopen_ftp_func(opaque, urlname, mode)
	voidpf          opaque;
	const char     *urlname;
	int             mode;
{
	/* We ignore the mode */
	struct ftp_stream *url_state;
	url_state = curl_adap_open_ftp_url(opaque, urlname);
	return url_state;
}


uLong ZCALLBACK 
fread_ftp_func(opaque, stream, buf, size)
	voidpf          opaque;
	voidpf          stream;
	void           *buf;
	uLong           size;
{
	uLong           ret = -1;
	ret = curl_adap_read(stream, buf, size);
	return ret;
}


uLong ZCALLBACK 
fwrite_ftp_func(opaque, stream, buf, size)
	voidpf          opaque;
	voidpf          stream;
	const void     *buf;
	uLong           size;
{
	uLong           ret = -1;
	/* Not implemented */
	return ret;
}

long ZCALLBACK 
ftell_ftp_func(opaque, stream)
	voidpf          opaque;
	voidpf          stream;
{
	struct ftp_stream *the_stream = (struct ftp_stream *) stream;
	return the_stream->current_pointer;

}

long ZCALLBACK 
fseek_ftp_func(opaque, stream, offset, origin)
	voidpf          opaque;
	voidpf          stream;
	uLong           offset;
	int             origin;
{

	int             fseek_origin = 0;
	struct ftp_stream *the_stream = (struct ftp_stream *) stream;
	switch (origin)
	{
	case ZLIB_FILEFUNC_SEEK_CUR:
		break;
	case ZLIB_FILEFUNC_SEEK_END:
		return curl_adap_seek_end(the_stream, offset);
		break;
	case ZLIB_FILEFUNC_SEEK_SET:
		break;
	default:
		return -1;
	}

	the_stream->current_pointer = offset;
	return 0L;
}

int ZCALLBACK 
fclose_ftp_func(opaque, stream)
	voidpf          opaque;
	voidpf          stream;
{
	int             ret;
	ret = curl_adap_close_ftp(stream);
	return ret;
}

int ZCALLBACK 
ferror_ftp_func(opaque, stream)
	voidpf          opaque;
	voidpf          stream;
{
	/* nothing to be returned */
	int             ret = 0;
	return ret;
}

void 
fill_ftp_filefunc(pzlib_filefunc_def)
	zlib_filefunc_def *pzlib_filefunc_def;
{

	pzlib_filefunc_def->zopen_file = fopen_ftp_func;
	pzlib_filefunc_def->zread_file = fread_ftp_func;
	pzlib_filefunc_def->zwrite_file = fwrite_ftp_func;
	pzlib_filefunc_def->ztell_file = ftell_ftp_func;
	pzlib_filefunc_def->zseek_file = fseek_ftp_func;
	pzlib_filefunc_def->zclose_file = fclose_ftp_func;
	pzlib_filefunc_def->zerror_file = ferror_ftp_func;
	pzlib_filefunc_def->opaque = NULL;
}
